import numpy as np
import sys
import petsc4py
from petsc4py import PETSc
petsc4py.init(sys.argv)


N = 24
comm = PETSc.COMM_WORLD
size = comm.getSize()
rank = comm.getRank()
coffe = PETSc.Mat().create(comm=comm)  # coffe
coffe.setSizes([3 * N, 3 * N])
coffe.setType('dense')
coffe.setFromOptions()
coffe.setPreallocationDense(None)

start = int(N / size) * rank
end = start + int(N / size)
# st, en = coffe.getOwnershipRange()
# start = int(st/3)
# end = int(en/3)

coffe.setValues(range(3 * N), range(3 * N), 2.0 * np.ones([3 * N, 3 * N]))
for i in range(start, end):
    sub = np.ones([3, 3])
    coffe.setValues(range(3 * i, 3 * i + 3), range(3 * i, 3 * i + 3), sub)

coffe.assemblyBegin(coffe.AssemblyType.FINAL)
coffe.assemblyEnd(coffe.AssemblyType.FINAL)
viewer = PETSc.Viewer().createASCII('coffe.dat', 'w')
viewer(coffe)





